<?php
/**
 * Flossy Theme Customizer.
 *
 * @package Flossy
 */

 if ( ! class_exists( 'Flossy_Customizer' ) ) {

	/**
	 * Customizer Loader
	 *
	 * @since 1.0.0
	 */
	class Flossy_Customizer {

		/**
		 * Instance
		 *
		 * @access private
		 * @var object
		 */
		private static $instance;

		/**
		 * Initiator
		 */
		public static function get_instance() {
			if ( ! isset( self::$instance ) ) {
				self::$instance = new self;
			}
			return self::$instance;
		}

		/**
		 * Constructor
		 */
		public function __construct() {
			/**
			 * Customizer
			 */
			 add_action( 'admin_enqueue_scripts',array( $this, 'flossy_admin_script' ) );
			add_action( 'customize_preview_init',                  array( $this, 'flossy_customize_preview_js' ) );
			add_action( 'customize_controls_enqueue_scripts',array( $this, 'flossy_customizer_script' ) );
			add_action( 'customize_register',                      array( $this, 'flossy_customizer_register' ) );
			add_action( 'after_setup_theme',                       array( $this, 'flossy_customizer_settings' ) );
		}
		
		/**
		 * Add postMessage support for site title and description for the Theme Customizer.
		 *
		 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
		 */
		function flossy_customizer_register( $wp_customize ) {
			
			$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
			$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
			$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
			$wp_customize->get_setting( 'background_color' )->transport = 'postMessage';
			$wp_customize->get_setting('custom_logo')->transport = 'refresh';
			
			/**
			 * Helper files
			 */
			require FLOSSY_PARENT_INC_DIR . '/customizer/sanitization.php';
		}

		/**
		 * Admin Script
		 */
		function flossy_admin_script() {
			wp_enqueue_style('flossy-admin-style', FLOSSY_PARENT_INC_URI . '/customizer/assets/css/admin.css');
			wp_enqueue_script( 'flossy-admin-script', FLOSSY_PARENT_INC_URI . '/customizer/assets/js/admin-script.js', array( 'jquery' ), '', true );
			wp_localize_script( 'flossy-admin-script', 'flossy_ajax_object',
				array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
			);
		}
		
		/**
		 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
		 */
		function flossy_customize_preview_js() {
			wp_enqueue_script( 'flossy-customizer', FLOSSY_PARENT_INC_URI . '/customizer/assets/js/customizer-preview.js', array( 'customize-preview' ), '20151215', true );
		}

		function flossy_customizer_script() {
			 wp_enqueue_script( 'flossy-customizer-section', FLOSSY_PARENT_INC_URI .'/customizer/assets/js/customizer-section.js', array("jquery"),'', true  );	
		}
		
		// Include customizer customizer settings.
			
		function flossy_customizer_settings() {
			require FLOSSY_PARENT_INC_DIR . '/customizer/customizer-options/flossy-header.php';
			require FLOSSY_PARENT_INC_DIR . '/customizer/customizer-options/flossy-blog.php';
			require FLOSSY_PARENT_INC_DIR . '/customizer/customizer-options/flossy-footer.php';
		    require FLOSSY_PARENT_INC_DIR . '/customizer/customizer-options/flossy-general.php';
			require FLOSSY_PARENT_INC_DIR . '/customizer/customizer-options/flossy_recommended_plugin.php';
			require FLOSSY_PARENT_INC_DIR . '/customizer/customizer-options/flossy-pro.php';
		}

	}
}// End if().

/**
 *  Kicking this off by calling 'get_instance()' method
 */
Flossy_Customizer::get_instance();